public class Vettore {

    private double X0;
    private double Y0;
    private double X1;
    private double Y1;

    public Vettore() {
        this.X0 = 0;
        this.Y0 = 0;
        this.X1 = 0;
        this.Y1 = 0;
    }

    public Vettore(double X0, double Y0, double X1, double Y1) {
        this.X0 = X0;
        this.Y0 = Y0;
        this.X1 = X1;
        this.Y1 = Y1;
    }

    public Vettore(Vettore v) {
        this.X0 = v.getX0();
        this.Y0 = v.getY0();
        this.X1 = v.getX1();
        this.Y1 = v.getY1();

    }


    public double getX0() {
        return X0;
    }

    public void setX0(double X0) {
        this.X0 = X0;
    }

    public double getX1() {
        return X1;
    }

    public void setX1(double X1) {
        this.X1 = X1;
    }

    public double getY0() {
        return Y0;
    }

    public void setY0(double Y0) {
        this.Y0 = Y0;
    }

    public double getY1() {
        return Y1;
    }

    public void setY1(double Y1) {
        this.Y1 = Y1;
    }

    public boolean equals(Vettore v) {
        if (v == null) {
            return false;
        }

        if (this.X0 != v.getX0()) {
            return false;
        }
        if (this.Y0 != v.getY0()) {
            return false;
        }
        if (this.X1 != v.getX1()) {
            return false;
        }
        if (this.Y1 != v.getY1()) {
            return false;
        }

        return true;
    }

    public String toString () {
        String t;

        t = "[(" + X0 + "," + Y0 + ");(" + X1 + "," + Y1 + ")]";
        return t;
    }

    public double length() {
        double l;

        l = Math.sqrt((this.X1-this.X0)*(this.X1-this.X0) + (this.Y1-this.Y0)*(this.Y1-this.Y0));
        return l;
    }



    public static void main(String[] args) {
        Vettore v1, v2, v3;

        v1 = new Vettore(0,0,1,1);
        System.out.println(v1);
        System.out.println(v1.length());

        v2 = new Vettore(0,1,1,0);
        System.out.println(v2);
        System.out.println(v2.length());

        v3 = new Vettore(v1);
        System.out.println(v3);
        System.out.println(v3.length());
        
        if (v1.equals(v2))
            System.out.println("Il vettore v1 ed il vettore v2 sono uguali");
        if (v2.equals(v3))
            System.out.println("Il vettore v2 ed il vettore v3 sono uguali");
        if (v1.equals(v3))
            System.out.println("Il vettore v1 ed il vettore v3 sono uguali");

    }
}